1 #!/bin/sh -- # no runable script, just for vi
3 # we all like colorful messages
4 CERROR
="\e[1;31m" # red
5 CWARNING
="\e[1;33m" # yellow
6 CMSG
="\e[1;32m" # green
7 CINFO
="\e[1;96m" # light blue
8 CDEBUG
="\e[1;94m" # blue
9 CNORMAL
="\e[0;39m" # default system console color
10 CDONE
="\e[1;32m" # green
11 CPASS
="\e[1;32m" # green
12 CFAIL
="\e[1;31m" # red
13 CCMD
="\e[1;35m" # pink
15 msgdie
() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16 msgwarn
() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17 msgmsg
() { echo "${CMSG}$1${CNORMAL}" >&2; }
18 msginfo
() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19 msgdebug
() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20 msgdone
() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21 msgnwarn
() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22 msgnmsg
() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23 msgninfo
() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24 msgndebug
() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25 msgtest
() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} …${CNORMAL} " >&2; }
26 msgpass
() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27 msgskip
() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28 msgfail
() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
30 # enable / disable Debugging
31 MSGLEVEL
=${MSGLEVEL:-3}
32 if [ $MSGLEVEL -le 0 ]; then
35 if [ $MSGLEVEL -le 1 ]; then
39 if [ $MSGLEVEL -le 2 ]; then
43 msgpass
() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
44 msgskip
() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
45 msgfail
() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
47 if [ $MSGLEVEL -le 3 ]; then
51 if [ $MSGLEVEL -le 4 ]; then
56 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
57 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
58 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
59 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
60 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
63 echo "${CDONE}DONE${CNORMAL}" >&2;
68 msgdebug
"Executing: ${CCMD}$*${CDEBUG} "
69 if [ -f .
/aptconfig.conf
]; then
70 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
71 elif [ -f ..
/aptconfig.conf
]; then
72 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
74 LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
77 aptconfig
() { runapt apt
-config $
*; }
78 aptcache
() { runapt apt
-cache $
*; }
79 aptget
() { runapt apt
-get $
*; }
80 aptftparchive
() { runapt apt
-ftparchive $
*; }
81 aptkey
() { runapt apt
-key $
*; }
82 aptmark
() { runapt apt
-mark $
*; }
84 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir
--force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir
/var
/log
/dpkg.log $
*
87 if [ -f .
/aptconfig.conf
]; then
88 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
89 elif [ -f ..
/aptconfig.conf
]; then
90 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
92 LD_LIBRARY_PATH
=${BUILDDIRECTORY} $(which aptitude) $
*
97 CURRENTTRAP
="$CURRENTTRAP $1"
98 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
102 TMPWORKINGDIRECTORY
=$(mktemp -d)
103 local TESTDIR
=$(readlink -f $(dirname $0))
104 msgninfo
"Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
105 BUILDDIRECTORY
="${TESTDIR}/../../build/bin"
106 test -x "${BUILDDIRECTORY}/apt-get" || msgdie
"You need to build tree first"
107 local OLDWORKINGDIRECTORY
=$(pwd)
108 addtrap
"cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY;"
109 cd $TMPWORKINGDIRECTORY
110 mkdir rootdir aptarchive keys
112 mkdir -p etc
/apt
/apt.conf.d etc
/apt
/sources.list.d etc
/apt
/trusted.gpg.d etc
/apt
/preferences.d
113 mkdir -p var
/cache var
/lib var
/log
114 mkdir -p var
/lib
/dpkg
/info var
/lib
/dpkg
/updates var
/lib
/dpkg
/triggers
115 local STATUSFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
116 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
117 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
119 touch var/lib/dpkg/status
121 touch var/lib/dpkg/available
123 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
125 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
126 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
127 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive
/Packages
129 local SOURCESSFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
130 if [ -f "${TESTDIR}/${SOURCESSFILE}" ]; then
131 cp "${TESTDIR}/${SOURCESSFILE}" aptarchive/Sources
133 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys/
134 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
135 echo "Dir
\"${TMPWORKINGDIRECTORY}/rootdir
\";" > aptconfig.conf
136 echo "Dir
::state
::status
\"${TMPWORKINGDIRECTORY}/rootdir
/var
/lib
/dpkg
/status
\";" >> aptconfig.conf
137 echo "Debug
::NoLocking
\"true
\";" >> aptconfig.conf
138 echo "APT
::Get
::Show
-User-Simulation-Note \"false
\";" >> aptconfig.conf
139 echo "Dir
::Bin
::Methods
\"${BUILDDIRECTORY}/methods
\";" >> aptconfig.conf
140 echo "Dir
::Bin
::dpkg
\"fakeroot
\";" >> aptconfig.conf
141 echo "DPKG
::options
:: \"dpkg
\";" >> aptconfig.conf
142 echo "DPKG
::options
:: \"--root=${TMPWORKINGDIRECTORY}/rootdir
\";" >> aptconfig.conf
143 echo "DPKG
::options
:: \"--force-not-root\";" >> aptconfig.conf
144 echo "DPKG
::options
:: \"--force-bad-path\";" >> aptconfig.conf
145 echo "DPKG
::options
:: \"--log=${TMPWORKINGDIRECTORY}/rootdir
/var
/log
/dpkg.log
\";" >> aptconfig.conf
146 echo 'quiet::NoUpdate "true
";' >> aptconfig.conf
148 export PATH="${PATH}:/usr
/local
/sbin
:/usr
/sbin
:/sbin
"
152 configarchitecture() {
153 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
154 echo "APT
::Architecture
\"$1\";" > $CONFFILE
156 while [ -n "$1" ]; do
157 echo "APT
::Architectures
:: \"$1\";" >> $CONFFILE
162 setupsimplenativepackage() {
166 local RELEASE="${4:-unstable}"
167 local DEPENDENCIES="$5"
168 local DESCRIPTION="$6"
169 local SECTION="${7:-others}"
171 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
174 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
176 local BUILDDIR=incoming/${NAME}-${VERSION}
177 mkdir -p ${BUILDDIR}/debian/source
179 echo "* most suckless software product ever
" > FEATURES
180 test -e debian/copyright || echo "Copyleft by Joe Sixpack
$(date +%Y)" > debian/copyright
181 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency
=low
185 -- Joe Sixpack
<joe@example.org
> $(date -R)" > debian/changelog
186 test -e debian/control || echo "Source
: $NAME
189 Maintainer
: Joe Sixpack
<joe@example.org
>
190 Build
-Depends: debhelper
(>= 7)
191 Standards
-Version: 3.9.1
193 Package
: $NAME" > debian/control
194 if [ "$ARCH" = 'all' ]; then
195 echo "Architecture
: all
" >> debian/control
197 echo "Architecture
: any
" >> debian/control
199 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
200 if [ -z "$DESCRIPTION" ]; then
201 echo "Description
: an autogenerated dummy
${NAME}=${VERSION}/${RELEASE}
202 If you
find such a package installed on your system
,
203 YOU did something horribly wrong
! They are autogenerated
204 und used only by testcases
for APT and surf no other propose…
" >> debian/control
206 echo "Description
: $DESCRIPTION" >> debian/control
208 test -e debian/compat || echo "7" > debian/compat
209 test -e debian/source/format || echo "3.0 (native
)" > debian/source/format
210 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
214 buildsimplenativepackage() {
218 local RELEASE="${4:-unstable}"
219 local DEPENDENCIES="$5"
220 local DESCRIPTION="$6"
221 local SECTION="${7:-others}"
222 local PRIORITY="${8:-optional}"
224 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
227 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
229 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
231 msgninfo "Build package
${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}…
"
232 mkdir -p $BUILDDIR/debian/source
233 echo "* most suckless software product ever
" > ${BUILDDIR}/FEATURES
235 echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
237 echo "Copyleft by Joe Sixpack
$(date +%Y)" > ${BUILDDIR}/debian/copyright
238 echo "$NAME ($VERSION) $RELEASE; urgency
=low
242 -- Joe Sixpack
<joe@example.org
> $(date -R)" > ${BUILDDIR}/debian/changelog
246 Maintainer
: Joe Sixpack
<joe@example.org
>
247 Standards
-Version: 3.9.1
249 Package
: $NAME" > ${BUILDDIR}/debian/control
250 if [ "$ARCH" = 'all' ]; then
251 echo "Architecture
: all
" >> ${BUILDDIR}/debian/control
253 echo "Architecture
: any
" >> ${BUILDDIR}/debian/control
255 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> ${BUILDDIR}/debian/control
256 if [ -z "$DESCRIPTION" ]; then
257 echo "Description
: an autogenerated dummy
${NAME}=${VERSION}/${RELEASE}
258 If you
find such a package installed on your system
,
259 YOU did something horribly wrong
! They are autogenerated
260 und used only by testcases
for APT and surf no other propose…
" >> ${BUILDDIR}/debian/control
262 echo "Description
: $DESCRIPTION" >> ${BUILDIR}/debian/control
264 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
265 local SRCS="$( (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
267 echo "pool
/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
270 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g'); do
271 rm -rf ${BUILDDIR}/debian/tmp
272 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
273 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
274 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}
275 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch)
276 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
278 dpkg-deb --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. 2> /dev/null > /dev/null
279 echo "pool
/${NAME}_
${VERSION}_
${arch}.deb
" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
282 mkdir -p ${BUILDDIR}/../${NAME}_${VERSION}
283 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}/
284 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}.changelog
293 msgninfo "Build package
$(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}…
"
295 if [ "$ARCH" = "all
" ]; then
296 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
298 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
299 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
300 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
303 echo "pool
/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
306 echo "pool
/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
312 if [ -d incoming ]; then
313 buildaptarchivefromincoming $*
315 buildaptarchivefromfiles $*
319 createaptftparchiveconfig() {
320 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb
$#\
1#' | tr '\n' ' ')"
321 if [ -z "$ARCHS" ]; then
322 # the pool is empty, so we will operate on faked packages - let us use the configured archs
323 ARCHS
="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
326 ArchiveDir "' >> ftparchive.conf
327 echo -n $(readlink -f .) >> ftparchive.conf
329 CacheDir "' >> ftparchive.conf
330 echo -n $(readlink -f ..) >> ftparchive.conf
332 FileListDir "' >> ftparchive.conf
333 echo -n $(readlink -f pool/) >> ftparchive.conf
337 Packages::Compress ". gzip bzip2 lzma xz";
338 Sources::Compress ". gzip bzip2 lzma xz";
339 Contents::Compress ". gzip bzip2 lzma xz";
340 Translation::Compress ". gzip bzip2 lzma xz";
341 LongDescription "false";
345 SrcDirectory "pool/";
351 Label "apttestcases";
353 Description "repository with dummy packages";
354 Architectures "' >> ftparchive.conf
355 echo -n "$ARCHS" >> ftparchive.conf
359 };' >> ftparchive.conf
360 for DIST
in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
361 echo -n 'tree "dists/' >> ftparchive.conf
362 echo -n "$DIST" >> ftparchive.conf
364 Architectures "' >> ftparchive.conf
365 echo -n "$ARCHS" >> ftparchive.conf
367 FileList "' >> ftparchive.conf
368 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
370 SourceFileList "' >> ftparchive.conf
371 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
373 Sections "' >> ftparchive.conf
374 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
376 };' >> ftparchive.conf
380 buildaptftparchivedirectorystructure
() {
381 local DISTS
="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
382 for DIST
in $DISTS; do
383 local SECTIONS
="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
384 for SECTION
in $SECTIONS; do
385 local ARCHS
="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
386 for ARCH
in $ARCHS; do
387 mkdir -p dists
/${DIST}/${SECTION}/binary
-${ARCH}
389 mkdir -p dists
/${DIST}/${SECTION}/source
390 mkdir -p dists
/${DIST}/${SECTION}/i18n
400 local DEPENDENCIES
="$5"
401 local PRIORITY
="${6:-optional}"
403 for arch
in $(echo "$ARCH" | sed -e 's#,#\n#g'); do
404 if [ "$arch" = "all" ]; then
405 ARCHS
="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
409 for BUILDARCH
in $ARCHS; do
410 local PPATH
="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
411 mkdir -p $PPATH aptarchive
/dists
/${RELEASE}/main
/source
412 touch aptarchive
/dists
/${RELEASE}/main
/source
/Sources
413 local FILE
="${PPATH}/Packages"
418 Maintainer: Joe Sixpack <joe@example.org>
421 Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
422 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
423 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
424 If you find such a package installed on your system,
425 YOU did something horribly wrong! They are autogenerated
426 und used only by testcases for APT and surf no other propose…
432 insertinstalledpackage
() {
436 local DEPENDENCIES
="$4"
437 local PRIORITY
="${5:-optional}"
438 local FILE
="rootdir/var/lib/dpkg/status"
439 for arch
in $(echo "$ARCH" | sed -e 's#,#\n#g'); do
441 Status: install ok installed
445 Maintainer: Joe Sixpack <joe@example.org>
447 Version: $VERSION" >> $FILE
448 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
449 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/installed
450 If you find such a package installed on your system,
451 YOU did something horribly wrong! They are autogenerated
452 und used only by testcases for APT and surf no other propose…
458 buildaptarchivefromincoming
() {
459 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
461 [ -e pool
] || ln -s ..
/incoming pool
462 [ -e ftparchive.conf
] || createaptftparchiveconfig
463 [ -e dists
] || buildaptftparchivedirectorystructure
464 msgninfo
"\tGenerate Packages, Sources and Contents files… "
465 aptftparchive
-qq generate ftparchive.conf
471 buildaptarchivefromfiles
() {
472 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
473 find aptarchive
-name 'Packages' -o -name 'Sources' | while read line
; do
474 msgninfo
"\t${line} file… "
475 cat ${line} | gzip > ${line}.gz
476 cat ${line} | bzip2 > ${line}.bz2
477 cat ${line} | lzma
> ${line}.lzma
478 cat ${line} | xz
> ${line}.xz
484 generatereleasefiles
() {
485 msgninfo
"\tGenerate Release files… "
486 local DATE
="${1:-now}"
487 if [ -e aptarchive
/dists
]; then
488 for dir
in $(find ./aptarchive/dists -mindepth 3 -maxdepth 3 -type d -name 'i18n'); do
489 aptftparchive
-qq release
$dir -o APT
::FTPArchive
::Release
::Patterns
::='Translation-*' > $dir/Index
491 for dir
in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
492 local CODENAME
="$(echo "$dir" | cut -d'/' -f 4)"
493 aptftparchive
-qq release
$dir -o APT
::FTPArchive
::Release
::Suite
="${CODENAME}" -o APT
::FTPArchive
::Release
::Codename
="${CODENAME}" | sed -e '/0 Release$/ d' > $dir/Release
# remove the self reference
494 if [ "$CODENAME" = "experimental" -o "$CODENAME" = "experimental2" ]; then
496 NotAutomatic: yes' $dir/Release
500 aptftparchive
-qq release .
/aptarchive
| sed -e '/0 Release$/ d' > aptarchive
/Release
# remove the self reference
502 if [ "$DATE" != "now" ]; then
503 for release
in $(find ./aptarchive -name 'Release'); do
504 touch -d "$1" $release
510 setupdistsaptarchive
() {
511 local APTARCHIVE
=$(readlink -f ./aptarchive)
512 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb.list
513 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb-src.list
514 for DISTS
in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
515 SECTIONS
=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
516 msgninfo
"\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
517 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb.list
518 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb-src.list
523 setupflataptarchive
() {
524 local APTARCHIVE
=$(readlink -f ./aptarchive)
525 if [ -f ${APTARCHIVE}/Packages
]; then
526 msgninfo
"\tadd deb sources.list line… "
527 echo "deb file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
530 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
532 if [ -f ${APTARCHIVE}/Sources
]; then
533 msgninfo
"\tadd deb-src sources.list line… "
534 echo "deb-src file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
537 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
543 if [ -e aptarchive
/dists
]; then
549 msgninfo
"\tSync APT's cache with the archive… "
555 local SIGNER
="${1:-Joe Sixpack}"
556 msgninfo
"\tSign archive with $SIGNER key… "
558 for KEY
in $(find keys/ -name '*.sec'); do
559 SECKEYS
="$SECKEYS --secret-keyring $KEY"
562 for KEY
in $(find keys/ -name '*.pub'); do
563 PUBKEYS
="$PUBKEYS --keyring $KEY"
565 for RELEASE
in $(find aptarchive/ -name Release); do
566 gpg
--yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg
${RELEASE}
567 gpg
--yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" --clearsign -o "$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" $RELEASE
572 changetowebserver
() {
573 if which weborf
> /dev
/null
; then
574 weborf
-xb aptarchive
/ 2>&1 > /dev
/null
&
576 elif which lighttpd
> /dev
/null
; then
577 echo "server.document-root = \"$(readlink -f ./aptarchive)\"
579 server.stat-cache-engine = \"disable\"" > lighttpd.conf
580 lighttpd
-t -f lighttpd.conf
>/dev
/null
|| msgdie
'Can not change to webserver: our lighttpd config is invalid'
581 lighttpd
-D -f lighttpd.conf
2>/dev
/null
>/dev
/null
&
584 msgdie
'You have to install weborf or lighttpd first'
587 local APTARCHIVE
="file://$(readlink -f ./aptarchive)"
588 for LIST
in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
589 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
595 local DIFFTEXT
="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
596 if [ -n "$DIFFTEXT" ]; then
608 msgtest
"Test for correctness of file" "$FILE"
610 echo -n "" | checkdiff
$FILE - && msgpass
|| msgfail
612 echo "$*" | checkdiff
$FILE - && msgpass
|| msgfail
617 local COMPAREFILE
=$(mktemp)
618 addtrap
"rm $COMPAREFILE;"
619 echo "$1" > $COMPAREFILE
621 msgtest
"Test for equality of" "$*"
622 $
* 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
626 local COMPAREFILE1
=$(mktemp)
627 local COMPAREFILE2
=$(mktemp)
628 local COMPAREAGAINST
=$(mktemp)
629 addtrap
"rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
630 echo "$1" > $COMPAREFILE1
631 echo "$2" > $COMPAREFILE2
633 msgtest
"Test for equality OR of" "$*"
634 $
* 2>&1 1> $COMPAREAGAINST
635 (checkdiff
$COMPAREFILE1 $COMPAREAGAINST 1> /dev
/null
||
636 checkdiff
$COMPAREFILE2 $COMPAREAGAINST 1> /dev
/null
) && msgpass
||
637 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
638 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
643 local VIRTUAL
="N: Can't select versions from package '$1' as it is purely virtual"
646 while [ -n "$1" ]; do
648 N: Can't select versions from package '$1' as it is purely virtual"
649 PACKAGE
="${PACKAGE} $1"
652 msgtest
"Test for virtual packages" "apt-cache show $PACKAGE"
654 N: No packages found"
655 local COMPAREFILE
=$(mktemp)
656 addtrap
"rm $COMPAREFILE;"
657 local ARCH
=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
658 eval `apt-config shell ARCH APT::Architecture`
659 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
660 aptcache show
-q=0 $PACKAGE 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
664 msgtest
"Test for non-existent packages" "apt-cache show $*"
665 local SHOWPKG
="$(aptcache show $* 2>&1 | grep '^Package: ')"
666 if [ -n "$SHOWPKG" ]; then
675 testdpkginstalled
() {
676 msgtest
"Test for correctly installed package(s) with" "dpkg -l $*"
677 local PKGS
="$(dpkg -l $* | grep '^i' | wc -l)"
678 if [ "$PKGS" != $# ]; then
680 dpkg
-l $
* | grep '^[a-z]'
687 testdpkgnotinstalled
() {
688 msgtest
"Test for correctly not-installed package(s) with" "dpkg -l $*"
689 local PKGS
="$(dpkg -l $* 2> /dev/null | grep '^i' | wc -l)"
690 if [ "$PKGS" != 0 ]; then
692 dpkg
-l $
* | grep '^[a-z]'
700 local COMPAREFILE
=$(mktemp)
701 addtrap
"rm $COMPAREFILE;"
703 msgtest
'Test for correctly marked as auto-installed' "$*"
704 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
706 msgtest
'Test for correctly marked as auto-installed' 'no package'
707 echo -n > $COMPAREFILE
709 aptmark showauto
2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
713 echo "STOPPED execution. Press enter to continue"